<template>
    <div class="modal fade" id="listModal" tabindex="-1" aria-labelledby="listModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-xl modal-dialog-centered"> 
        <!-- <div class="modal-dialog modal-xl"> --><!-- Pantalla completa -->
        <div class="modal-content" style="background-color: aliceblue">
          <div class="modal-header">
            <h5 class="modal-title h4" id="listModalLabel">{{data.title}}</h5>
            <button type="button" class="btn-close" aria-label="Close" @click="modalHide()"></button>
          </div>
          <div class="modal-body">
            <table-image 
              ref="table"
              :files="data.files" 
              @removeElementFromList="removeElementFromList"
              @addNotification="addNotification"
            ></table-image>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" @click="modalHide()">Cerrar</button>
          </div>
        </div>
        <toast-alert ref="toastAlert"></toast-alert>
      </div>
    </div>
</template>

<script setup lang="ts">
import { inject, onMounted, reactive, ref } from 'vue';
import { documentsListKey } from "./documentslist";
import Modal from 'bootstrap/js/dist/modal';
import axios from 'axios';
import TableImage from './components/Table.vue';
import ToastAlert from './components/ToastAlert.vue';


const table = ref<typeof TableImage>();
const hcdListOptions = inject(documentsListKey);
const toastAlert = ref<typeof ToastAlert>();
const data = reactive({
  modal: null as Modal | null,
  files: [],
  title: ""
});

onMounted(()=> {
  data.modal = new Modal('#listModal');
});

async function show(app_config: any, params: object) {
  return new Promise((resolve, reject )=> {
    data.title = (typeof app_config.title != 'undefined')? app_config.title : "Listado";

    axios.post(hcdListOptions!.base_url + '/escaner/getDocumentosEscaneados',params)
    .then((response) => {
      if (response.status == 200) {
        data.files = response.data.res;
        data.modal!.show();
        resolve("Exito");
      } 
      reject("Error");
    })
    .catch((error) => {
      reject(error.message);
    });
  });
}

async function showFirstFile(app_config: any, params: object) {
  return new Promise((resolve, reject )=> {
    axios.post(hcdListOptions!.base_url + '/escaner/getDocumentosEscaneados',params)
    .then((response) => {
      if (response.status == 200) {
        data.files = response.data.res;
        table.value!.abrir(data.files[0]);
        resolve("Exito");
      } 
      reject("Error");
    })
    .catch((error) => {
      reject(error.message);
    });
  });
}

function removeElementFromList(index: number){
  data.files.splice(index,1);
}

function addNotification(msg: string){
  toastAlert.value!.addNotification(msg);
}

function modalHide(){
  data.modal!.hide();
}

defineExpose({
  show,
  showFirstFile
});

</script>
